unit LPTComm;

interface
var waitnum:integer;

procedure InitPort(PortNum:integer);
procedure CommStart(CLatchPort,CLatchVal:integer;neg:boolean);
procedure CommStop(CLatchPort,CLatchVal:integer;neg:boolean);
procedure ResetAD(Value:boolean);
procedure SendByte(value:integer);
function GetByte:integer;

implementation
uses IOPort;
var LPT:integer;

procedure InitPort(PortNum:integer);
begin
 if not StartUpIoPorts(PortNum) then halt;
 if not StartUpIoPorts(PortNum+1) then halt;
 if not StartUpIoPorts(PortNum+2) then halt;
 LPT:=PortNum;
end;

function cin:boolean;
begin
 cin:=inportb(LPT+1) and 8>0;
end;

procedure cdata(b:byte);
begin
 if b=1 then outportb(LPT,(inportb(LPT) or 1))
        else outportb(LPT,(inportb(LPT) and 254));
end;

procedure clatch(b:byte;CLatchPort,CLatchVal:integer;neg:boolean);
begin
 if ((not neg) and (b=1)) or (neg and (b=0)) then outportb(CLatchPort,(inportb(LPT) or CLatchVal))
        else outportb(CLatchPort,(inportb(LPT) and (255-CLatchVal)));
end;

procedure cclk(b:byte);
var i:integer;
begin
 for i:=1 to waitnum do ;
 if b=1 then outportb(LPT,(inportb(LPT) or 4))
        else outportb(LPT,(inportb(LPT) and 251));
 for i:=1 to waitnum do ;
end;


procedure CommStart(CLatchPort,CLatchVal:integer;neg:boolean);
var i:integer;
begin
 for i:=1 to waitnum do ;
 clatch(0,CLatchPort,CLatchVal,neg);
 for i:=1 to waitnum do ;
end;

procedure CommStop(CLatchPort,CLatchVal:integer;neg:boolean);
begin
 clatch(1,CLatchPort,CLatchVal,neg);
end;

procedure ResetAD(Value:boolean);
begin
 if value then outportb(LPT,(inportb(LPT) or 8))
        else outportb(LPT,(inportb(LPT) and (255-8)));
end;

procedure SendByte(value:integer);
var i:integer;
const p2na:array[0..7] of byte=(1,2,4,8,16,32,64,128);
begin
 for i:=7 downto 0 do begin
  if (value and p2na[i])=0 then begin
   cdata(0);
  end else begin
   cdata(1);
  end;
  cclk(1);
  cclk(0);
 end;
end;

function GetByte:integer;
var i:integer;
const p2na:array[0..7] of byte=(1,2,4,8,16,32,64,128);
begin
 result:=0;
 for i:=7 downto 0 do begin
  if cin then result:=result+p2na[i];
  cclk(1);
  cclk(0);
 end;
end;

begin
 waitnum:=0;
end.
