unit dkPanel;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, mLED, FatScrollBar, StdCtrls, ComCtrls,math, MPlayer,
  Menus,dkTranslator;

type
 TEQState=(dbsGain,dbsEQ);
type TEQConnect=(dbcNone,dbcDirect,dbcDelta);
type TEQBand=record

                 freq:real;q:real;
                 state:TEQState;
                 connect:TEQConnect;
                 posleft,posright:integer;

             end;

type TDoubleBiquad=class
                    id:integer;
                    freq:real;
                    q:real;
                    state:TEQState;
                    connect:TEQConnect;
                    dbgainLeft,dbgainRight:real;
                    sbLeft:TFatScrollBar;
                    sbRight:TFatScrollBar;
                    lblLeft:TLabel;
                    lblRight:TLabel;
                    Led:TmLed;
                    shape:TShape;
                    Btn:TButton;
                    constructor Create(iid:integer;parent:TCustomForm);
                    procedure RedrawUI;
                    procedure BtnMouseDown(Sender: TObject;Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
                    procedure LedClick(Sender: TObject);
                    procedure sbChange(Sender: TObject);
                    procedure SetFilter(Sender: TObject);
                   end;
  TNineBiq=array[1..9] of TDoubleBiquad;

type TLimiterData=array[1..33] of record
                                                output:integer;
                                                outputq:integer;
                                                gain:real;
                                               end;


  TVolCon=(vbcNone,vbcDirect,vbcDelta);
  TTriSubBi=array[1..3] of record
                    id:integer;
                    freq:real;
                    q:real;
                    state:(bsGain,bsEQ);
                    end;
  TfrmPanel = class(TForm)
    sbA: TFatScrollBar;
    sbB: TFatScrollBar;
    sbC: TFatScrollBar;
    sbVolLeft: TFatScrollBar;
    sbVolRight: TFatScrollBar;
    Bevel1: TBevel;
    sbVolSub: TFatScrollBar;
    sbSubInLeft: TFatScrollBar;
    sbSubInRight: TFatScrollBar;
    btnA: TButton;
    btnB: TButton;
    btnC: TButton;
    rgSub: TRadioGroup;
    gbExpander: TGroupBox;
    sbStereoExpLevel: TFatScrollBar;
    Label4: TLabel;
    Label5: TLabel;
    sbStereoExpMaxFreq: TFatScrollBar;
    gbDelay: TGroupBox;
    sbDelLeft: TFatScrollBar;
    sbDelRight: TFatScrollBar;
    sbDelSub: TFatScrollBar;
    Label6: TLabel;
    sbReinjectLeft: TFatScrollBar;
    sbReinjectRight: TFatScrollBar;
    ldVolume: TmLED;
    cbHinty: TCheckBox;
    ldMute: TmLED;
    btnMute: TButton;
    ldShutdown: TmLED;
    btnShutdown: TButton;
    lblVolLeft: TLabel;
    lblVolRight: TLabel;
    lblVolSub: TLabel;
    btnVSlow: TButton;
    btnVFast: TButton;
    ldVSlow: TmLED;
    ldVFast: TmLED;
    lblSubInp: TLabel;
    cbXminus1: TCheckBox;
    cbXRminus1: TCheckBox;
    lblDelays: TLabel;
    bgShape: TImage;
    ldError: TmLED;
    gbLimiter: TGroupBox;
    lblDb: TLabel;
    sbSamples: TScrollBar;
    sbGain: TScrollBar;
    lblSamples: TLabel;
    lblGain: TLabel;
    btnLSave: TButton;
    btnLOpen: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    lblMaxFreq: TLabel;
    lblStereoExpLevel: TLabel;
    imgLimiter: TImage;
    lblDbOut: TLabel;
    ldLimErr: TmLED;
    lblReinject: TLabel;
    btnSLimLoad: TButton;
    gbSLimiter: TGroupBox;
    lblSDb: TLabel;
    lblSSamples: TLabel;
    lblSGain: TLabel;
    imgSLimiter: TImage;
    lblSDbOut: TLabel;
    ldSLimErr: TmLED;
    sbSSamples: TScrollBar;
    sbSGain: TScrollBar;
    btnSubLimSave: TButton;
    btnMainToSub: TButton;
    btnSubToMain: TButton;
    btnDeemph: TButton;
    ldDeemph: TmLED;
    Label1: TLabel;
    pbMain: TProgressBar;
    Label2: TLabel;
    ldVUMetr: TmLED;
    btnVUMetr: TButton;
    tVUMetr: TTimer;
    pbSub: TProgressBar;
    shMLIn: TShape;
    shSLIn: TShape;
    shMLOut: TShape;
    shSLOut: TShape;
    Label3: TLabel;
    Label7: TLabel;
    btnVULimiter: TButton;
    ldVULimiter: TmLED;
    btnEQLoad: TButton;
    btnEQSave: TButton;
    SaveDialog2: TSaveDialog;
    OpenDialog2: TOpenDialog;
    procedure DrawLimiter;
    procedure DrawSLimiter;
    procedure FormCreateEx(Sender: TObject);
    procedure btnMuteClick(Sender: TObject);
    procedure btnShutdownClick(Sender: TObject);
    procedure sbVolLeftChange(Sender: TObject);
    procedure ldVolumeClick(Sender: TObject);
    procedure btnVSlowClick(Sender: TObject);
    procedure btnVFastClick(Sender: TObject);
    procedure cbHintyClick(Sender: TObject);
    procedure rgSubClick(Sender: TObject);
    procedure sbSubInLeftChange(Sender: TObject);
    procedure SetDelays(Sender: TObject);
    procedure cbDeemphClick(Sender: TObject);
    procedure SetSubBiquad(Sender: TObject);
    procedure btnAMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnBMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnCMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnAClick(Sender: TObject);
    procedure sbSamplesChange(Sender: TObject);
    procedure sbGainChange(Sender: TObject);
    procedure btnLSaveClick(Sender: TObject);
    procedure btnLOpenClick(Sender: TObject);
    procedure sbStereoExpLevelChange(Sender: TObject);
    procedure sbStereoExpMaxFreqChange(Sender: TObject);
    procedure imgLimiterMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure imgLimiterMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure sbReinjectLeftChange(Sender: TObject);
    procedure imgSLimiterMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure imgSLimiterMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure sbSSamplesChange(Sender: TObject);
    procedure sbSGainChange(Sender: TObject);
    procedure btnMainToSubClick(Sender: TObject);
    procedure btnSubToMainClick(Sender: TObject);
    procedure btnVUClick(Sender: TObject);
    procedure tVUMetrTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnVULimiterClick(Sender: TObject);
    procedure btnEQSaveClick(Sender: TObject);
    procedure btnEQLoadClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure btnVUMetrMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
       vulimiter:boolean;
   mainlim:TLimiterData;
   sublim:TLimiterData;
   biquads:TNineBiq;
   volconnect:TVolCon;
   subbiquads:TTriSubBi;
   visibleLed:TMLed;
   backlink:TObject;
   AD:TAD1954;
  end;
var
  frmPanel: TfrmPanel;
procedure CreateFilters(parent:TfrmPanel);

implementation
uses Main,lptcomm,dkSetBiquad;
{$R *.dfm}



function In300(value:integer):integer;
begin
 result:=value;
 if value<0 then result:=0;
 if value>300 then result:=300;
end;

procedure SbsShowDb(sender:TObject);
var val:integer;
begin
 val:=((sender As TScrollBar).Position);
 frmPanel.lblDb.caption:=formatfloat('0.00',20*log10((200-val)*0.01+0.01))+'dB';
end;


procedure TDoubleBiquad.SetFilter(Sender: TObject);
var dialog:TfrmFilterSetup;
begin
 dialog:=TfrmFilterSetup.Create(frmPanel);
 if state=dbsGain then begin
  dialog.rgKind.ItemIndex:=1;
  dialog.edFreq.Enabled:=false;
  dialog.edQ.Enabled:=false;
 end;
 dialog.edFreq.Text:=formatfloat('0.0',freq);
 dialog.edQ.Text:=formatfloat('0.000',q);
 if dialog.ShowModal=mrOK then begin
  try
   freq:=StrToFloat(dialog.edFreq.text);
   q:=StrToFloat(dialog.edQ.text);
   if dialog.rgKind.ItemIndex=1 then state:=dbsGain else state:=dbsEQ;
  except
   on E:Exception do Showmessage('Chyba: '+E.message);
  end;
 end;
 dialog.Free;
 RedrawUI;
end;

procedure TDoubleBiquad.BtnMouseDown(Sender: TObject;Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
if mbRight = Button then if state=dbsEQ then
  state:=dbsGain else state:=dbsEQ;
 RedrawUI;
end;

procedure TDoubleBiquad.sbChange(Sender: TObject);
begin
 RedrawUI;
end;

procedure TDoubleBiquad.LedClick(Sender: TObject);
begin
 //prepinani zavislosti
 if connect=dbcDirect then connect:=dbcNone else
 if connect=dbcDelta then connect:=dbcDirect else
 if connect=dbcNone then connect:=dbcDelta;
 //proved prepocet hodnot posuvniku
 case connect of dbcNone:sbRight.Position:=In300(sbRight.Position-150)+sbLeft.Position;
                 dbcDelta:sbRight.Position:=In300(sbRight.Position-sbLeft.Position+150);
 end;
 RedrawUI;
end;

procedure TDoubleBiquad.RedrawUI;
var biqid:integer;freql,freqr:integer;
begin

 //vzhled tlacitka, shapu
 btn.Font.Style:=[fsBold];
 if state=dbsEQ then begin
  btn.Caption:=inttostr(id);
  shape.Height:=10;
  shape.Width:=15;
  freql:=round(freq)-round(freq/2/q);
  freqr:=round(freq)+round(freq/2/q);
  if freql<0 then freql:=0;
  if freqr>20000 then freqr:=20000;
  shape.Left:=316+round(log10(freql/1000+1)*276);
  shape.width:=316+round(log10(freqr/1000+1)*276)-shape.Left;
  shape.Visible:=true;
 end else begin
  shape.Visible:=false;
  btn.Caption:='G';
  btn.Font.Color:=clBlack;
 end;
 //barva posuvniku
 if state=dbsEQ then begin
  if id<8 then
   sbLeft.StyleScroller.Fill.ColorCold:=((255*id) div 7)*$10000
  else sbLeft.StyleScroller.Fill.ColorCold:=((id-8)*64+64)*$100;
 end else begin
   sbLeft.StyleScroller.Fill.ColorCold:=clYellow;
 end;
 shape.Brush.Color:=sbLeft.StyleScroller.Fill.ColorCold;
 sbLeft.StyleScroller.Border.ColorCold:=sbLeft.StyleScroller.Fill.ColorCold;
 sbRight.StyleScroller.Border.ColorCold:=sbLeft.StyleScroller.Fill.ColorCold;
 sbRight.StyleScroller.FIll.ColorCold:=sbLeft.StyleScroller.Fill.ColorCold;
 //vzhled LED diody, posuvniku pri zavislosti
 dbGainLeft:=(150-sbLeft.Position)*0.1;
 case connect of
  dbcNone:begin
           Led.Color:=lcBlue;
           Led.State:=lsOff;
           sbRight.Visible:=true;
           sbRight.StyleTrack.Fill.ColorCold:=clWhite;
           dbGainRight:=(150-sbRight.Position)*0.1;
          end;
  dbcDirect:begin
           Led.Color:=lcBlue;
           Led.State:=lsOn;
           sbRight.Visible:=false;
           dbGainRight:=dbGainLeft;
          end;
  dbcDelta:begin
           Led.Color:=lcGreen;
           Led.State:=lsOn;
           sbRight.Visible:=true;
           sbRight.StyleTrack.Fill.ColorCold:=clCream;
           dbGainRight:=dbGainLeft+(150-sbRight.Position)*0.1;
          end;

 end;
 //proved zobrazeni hodnot
 lblLeft.caption:=formatfloat('0.0;-0.0;"-"',dbGainLeft);
 shape.Top:=8+45-3-round(dbgainLeft)*2;
 lblRight.caption:=formatfloat('0.0;-0.0;"-"',dbGainRight);
 if state=dbsEQ then begin
  if id in [1..7] then biqid:=id-1 else biqid:=14+(id-8);
  if not (sbLeft.Parent as TfrmPanel).AD.BiquadEQ((biqid),true,freq,q,dbGainLeft) then Led.Color:=lcRed;
  if id in [1..7] then biqid:=7+id-1 else biqid:=16+(id-8);
  if not (sbLeft.Parent as TfrmPanel).AD.BiquadEQ((biqid),true,freq,q,dbGainRight) then Led.Color:=lcRed;
 end else begin
  if id in [1..7] then biqid:=id-1 else biqid:=14+(id-8);
  if not (sbLeft.Parent as TfrmPanel).AD.BiquadGain((biqid),true,dbGainLeft) then Led.Color:=lcRed;
  if id in [1..7] then biqid:=7+id-1 else biqid:=16+(id-8);
  if not (sbLeft.Parent as TfrmPanel).AD.BiquadGain((biqid),true,dbGainRight) then Led.Color:=lcRed;
 end;
end;

constructor TDoubleBiquad.Create(iid:integer;parent:TCustomForm);
begin
 inherited Create;
 state:=dbsEQ;
 connect:=dbcDelta;
 id:=iid;
 case id of
     1:freq:=60;
     2:freq:=180;
     3:freq:=430;
     4:freq:=1000;
     5:freq:=3000;
     6:freq:=7300;
     7:freq:=15000;
     8:freq:=300;
     9:freq:=7000;
 end;
 case id of
     1:   q:=0.7;
     2:   q:=1.45;
     3:   q:=1.25;
     4:   q:=1.45;
     5:   q:=1;
     6:   q:=1.45;
     7:   q:=1.6;
     8:   q:=0.6;
     9:   q:=0.8;
 end;
 sbLeft:=TFatScrollBar.Create(parent);
 sbLeft.Parent:=parent;
 sbLeft.Left:=8+(id-1)*24;
 if id=8 then sbLeft.Left:=192;
 if id=9 then sbLeft.Left:=216;
 sbLeft.Top:=72;
 sbLeft.Width:=17;
 sbLeft.Height:=105;
 sbLeft.Visible:=true;
 sbLeft.Max:=300;
 sbLeft.Position:=150;
 sbLeft.Kind:=sbVertical;
 sbLeft.ArrowStretch:=35;
 sbLeft.ArrowWidth:=18;
 sbLeft.Tag:=id;
 sbRight:=TFatScrollBar.Create(parent);
 sbRight.Parent:=parent;
 sbRight.Left:=sbLeft.Left;
 sbRight.Top:=200;
 sbRight.Width:=17;
 sbRight.Height:=105;
 sbRight.Visible:=true;
 sbRight.Max:=300;
 sbRight.Kind:=sbVertical;
 sbRight.Position:=150;
 sbRight.Tag:=id;
 sbLeft.OnChange:=sbChange;
 sbRight.OnChange:=sbChange;
 shape:=TShape.Create(parent);
 shape.Parent:=parent;
 shape.Visible:=false;
 shape.Shape:=stRoundRect;
 lblLeft:=TLabel.Create(parent);
 lblLeft.Parent:=parent;
 lblLeft.AutoSize:=false;
 lblLeft.Left:=sbLeft.Left-4;
 lblLeft.Width:=25;
 lblLeft.Top:=56;
 lblLeft.Height:=18;
 lblLeft.Alignment:=taCenter;
 lblLeft.Caption:='0';
 lblRight:=TLabel.Create(parent);
 lblRight.Parent:=parent;
 lblRight.AutoSize:=false;
 lblRight.Left:=sbLeft.Left-4;
 lblRight.Width:=25;
 lblRight.Top:=184;
 lblRight.Height:=18;
 lblRight.Alignment:=taCenter;
 lblRight.Caption:='0';
 Led:=TmLED.Create(parent);
 Led.Hint:='Nastaven zvislosti lev/prav kanl (zmte klikutm):'+#10#13+
           'Modr svt: oba kanly stejn; modr nesvt: oddlen'+#10#13+
           'zelen svt: ovld se levm kanlem, hodnota pravho je posunuta (+/-) od levho podle svho posuvnku.';
 Led.Parent:=parent;
 Led.Left:=sbLeft.Left-3;
 Led.Top:=32;
 Led.Size:=lzNormal;
 Led.Color:=lcBlue;
 Led.State:=lsOn;
 Led.OnClick:=LedClick;
 Btn:=TButton.Create(parent);
 Btn.Parent:=parent;
 btn.Hint:='Lev klik->nastaven parametr, prav klik-> zmna filtr (slo)/zesilova (psmeno G)';
 Btn.Caption:=inttostr(id);
 Btn.Top:=8;
 Btn.Tag:=id;
 Btn.Width:=17;
 Btn.Height:=25;
 Btn.Left:=sbLeft.Left;
 Btn.OnMouseDown:=BtnMouseDown;
 Btn.OnClick:=SetFilter;
 RedrawUI;
end;

procedure CreateFilters(parent:TfrmPanel);
var i,x:integer;
begin
 //vytvor filtry
 for i:=1 to 9 do parent.biquads[i]:=TDoubleBiquad.Create(i,parent);
end;


procedure TfrmPanel.FormCreateEx(Sender: TObject);
var i,x:integer;
begin
 AD:=TAD1954.CreateLPT(GlobalLPT,(backlink As TADHandler).devinfo.clport,(backlink As TADHandler).devinfo.clval,(backlink As TADHandler).devinfo.neguje);
 //vytvor limiter
 for i:=1 to 33 do mainlim[i].output:=-150;
 for i:=1 to 33 do  sublim[i].output:=-150;
 mainlim[1].output:=-93;
 mainlim[33].output:=3;
  sublim[1].output:=-93;
  sublim[33].output:=3;
 DrawLimiter;
 DrawSLimiter;
 //init - volume
 volconnect:=vbcDelta;
 ldVolumeClick(sender);
 //init - stupnice
 bgShape.Canvas.Brush.Style:=bsSolid;
 bgShape.Canvas.Brush.color:=clWhite;
 bgShape.Canvas.Rectangle(0,0,393,105);
 bgShape.Canvas.Pen.Color:=clAqua;
 bgShape.Canvas.Pen.Width:=1;
 for i:=0 to 18 do begin
  x:=round(log10(i+1)*276)+20;
  bgShape.Canvas.MoveTo(x,14);
  bgShape.Canvas.LineTo(x,95);
  if (i<9) or (i mod 2=0) then bgShape.Canvas.TextOut(x-2,3,inttostr(i));
 end;
 bgShape.Canvas.MoveTo(3,15);
 bgShape.Canvas.LineTo(390,15);
 bgShape.Canvas.MoveTo(3,15+30);
 bgShape.Canvas.LineTo(390,15+30);
 bgShape.Canvas.MoveTo(3,15+60);
 bgShape.Canvas.LineTo(390,15+60);
 //init - subbiquady
 subbiquads[1].freq:=50;
 subbiquads[1].q:=1.2;
 subbiquads[1].state:=bsEQ;
 subbiquads[2].freq:=200;
 subbiquads[2].q:=1.5;
 subbiquads[2].state:=bsEQ;
 subbiquads[3].freq:=5000;
 subbiquads[3].q:=1;
 subbiquads[3].state:=bsEQ;
 setsubbiquad(sender);
end;


procedure TfrmPanel.btnMuteClick(Sender: TObject);
begin
 if AD.GetMute then begin
  AD.SetMute(false);
  ldMute.State:=lsOff;
  (backlink as TADHandler).ldMute.State:=lsOff;
 end else begin
  AD.SetMute(true);
  ldMute.State:=lsOn;
  (backlink as TADHandler).ldMute.State:=lsOn;
 end;
end;

procedure TfrmPanel.btnShutdownClick(Sender: TObject);
begin
 if AD.GetPowerDown then begin
  AD.SetPowerDown(false);
  ldShutdown.State:=lsOff;
 end else begin
  AD.SetPowerDown(true);
  ldShutdown.State:=lsOn;
 end;
end;

procedure TfrmPanel.sbVolLeftChange(Sender: TObject);
var volleft,volright,volsub:real;
begin
 //nastaveni hlasitosti
 //moznost nastavovani z mixu
 if (sender<>sbVolLeft) and (sender<>sbVolRight) then begin
  if (sender is TScrollBar) then sbVolLeft.position:=(sender as TScrollBar).Position;
 end else
  (backlink as TADHandler).sbMix.Position:=sbVolLeft.Position;
 //levy - je presne podle posuvniku
 volleft:=(60-sbVolLeft.Position)/10;
 lblVolLeft.caption:=formatfloat('0.0dB;-0.0dB;"0 dB"',volleft);
 if volleft=-40 then begin
  lblvolleft.caption:='MUTE';
  volleft:=-1000;
 end;
 AD.SetVolLeft(mocnina(10,volleft/20)-0.001);
 //pravy
 case volconnect of
  vbcNone: volright:=(60-sbVolRight.Position)/10;
  vbcDirect: begin
              volright:=volleft;
              sbVolRight.Position:=sbVolLeft.Position;
             end;
  else volright:=volleft+(60-sbVolRight.Position)/10;
 end;
 lblVolRight.caption:=formatfloat('0.0dB;-0.0dB;"0 dB"',volright);
 if volright<=-40 then begin
  lblvolright.caption:='MUTE';
  volright:=-1000;
 end;
 AD.SetVolRight(mocnina(10,volright/20)-0.001);
 //sub
 case rgSub.ItemIndex of
  0:volsub:=(60-sbVolSub.Position)/10;
  1:begin
     volsub:=(volleft+volright)/2;
     try
      sbVolSub.position:=round(60-(volleft+volright)*5);
     finally
     end;
    end;
  else volsub:=(60-sbVolSub.Position)/10+volleft;
 end;
 lblVolSub.caption:=formatfloat('0.0dB;-0.0dB;"0 dB"',volsub);
 if volsub<=-40 then begin
  lblvolsub.caption:='MUTE';
  volsub:=-1000;
 end;
 AD.SetVolSub(mocnina(10,volsub/20)-0.001);
end;

procedure TfrmPanel.ldVolumeClick(Sender: TObject);
begin
 //prepinani zavislosti
 if volconnect=vbcDirect then volconnect:=vbcNone else
 if volconnect=vbcDelta then volconnect:=vbcDirect else
 if volconnect=vbcNone then volconnect:=vbcDelta;
 //proved prepocet hodnot posuvniku
 case volconnect of vbcNone:sbVolRight.Position:=sbVolLeft.Position;
                 vbcDelta:sbVolRight.Position:=60;
 end;
 //barva LED
 case volconnect of
  vbcNone:begin
           ldVolume.Color:=lcBlue;
           ldVolume.State:=lsOff;
           sbVolRight.Enabled:=true;
           sbVolRight.StyleTrack.Fill.ColorCold:=clWhite;
          end;
  vbcDirect:begin
           ldVolume.Color:=lcBlue;
           ldVolume.State:=lsOn;
           sbVolRight.Enabled:=false;
          end;
  vbcDelta:begin
           ldVolume.Color:=lcGreen;
           ldVolume.State:=lsOn;
           sbVolRight.Enabled:=true;
           sbVolRight.StyleTrack.Fill.ColorCold:=clCream;
          end;
 end;
 sbVolLeftChange(sender);
end;

procedure TfrmPanel.btnVSlowClick(Sender: TObject);
begin
 AD.SetVolumeRamp(vrSlow);
 ldVSlow.state:=lsOn;
 ldVFast.state:=lsOff;
end;

procedure TfrmPanel.btnVFastClick(Sender: TObject);
begin
 AD.SetVolumeRamp(vrFast);
 ldVSlow.state:=lsOff;
 ldVFast.state:=lsOn;
end;

procedure TfrmPanel.cbHintyClick(Sender: TObject);
begin
 frmPanel.ShowHint:=cbHinty.Checked;
end;

procedure TfrmPanel.rgSubClick(Sender: TObject);
begin
 sbVolSub.enabled:=rgSub.ItemIndex<>1;
 case rgSub.ItemIndex of
  0:sbVolSub.position:=(sbVolLeft.position+sbVolRight.position) div 2;
  1:sbVolSub.position:=(sbVolLeft.position+sbVolRight.position) div 2;
  2:sbVolSub.position:=60;
 end;
end;

procedure TfrmPanel.sbSubInLeftChange(Sender: TObject);
var subinl,subinr:real;
begin
 subinl:=(20-sbSubInLeft.Position)*0.1;
 subinr:=(20-sbSubInRight.Position)*0.1;
 if cbXminus1.checked then subinl:=-subinl;
 if cbXRminus1.checked then subinr:=-subinr;
 lblSubInp.caption:=formatfloat('0.0',subinl)+' / '+formatfloat('0.0',subinr);
 AD.CmdSafe(189,subinl);
 AD.CmdSafe(190,subinr);
end;

procedure TfrmPanel.SetDelays(Sender: TObject);
begin
 AD.Cmd(182,0,0,165-sbDelLeft.Position);
 AD.Cmd(183,0,0,165-sbDelRight.Position);
 AD.Cmd(184,0,0,165-sbDelSub.Position);
 lblDelays.Caption:=formatfloat('0.0',0.0208*(165-sbDelLeft.Position ))+'/'+
                    formatfloat('0.0',0.0208*(165-sbDelRight.Position))+'/'+
                    formatfloat('0.0',0.0208*(165-sbDelSub.Position  ))+'ms';
end;

procedure TfrmPanel.cbDeemphClick(Sender: TObject);
begin
 if AD.GetDeemphasis=deeNone then begin
  AD.SetDeemphasis(dee48);
  ldDeemph.State:=lsOn;
 end else begin
  AD.SetDeemphasis(deeNone);
  ldDeemph.State:=lsOff;
 end;

end;

procedure TfrmPanel.SetSubBiquad(Sender: TObject);
var i:integer;gain:real;
begin
 //posle data pro biquady subwooferu
 ldError.State:=lsOff;
 for i:=1 to 3 do begin
   case i of
    1:gain:=0.1*(150-sbA.Position);
    2:gain:=0.1*(150-sbB.Position);
    3:gain:=0.1*(150-sbC.Position);
    else gain:=0;
   end;
   if subbiquads[i].state=bsEQ then begin
    if not AD.BiquadEQ(17+i,true,subbiquads[i].freq,subbiquads[i].q,gain) then ldError.State:=lsOn;
   end else begin
    if not AD.BiquadGain(17+i,true,gain) then ldError.State:=lsOn;
   end;
 end;
end;

procedure TfrmPanel.btnAMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if button=mbRight then begin
  if subbiquads[1].state=bsEQ then subbiquads[1].state:=bsGain else
  subbiquads[1].state:=bsEQ;
  if subbiquads[1].state=bsEQ then btnA.Caption:='A' else btnA.Caption:='G';
 end;
end;

procedure TfrmPanel.btnBMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if button=mbRight then begin
  if subbiquads[2].state=bsEQ then subbiquads[2].state:=bsGain else
  subbiquads[2].state:=bsEQ;
  if subbiquads[2].state=bsEQ then btnB.Caption:='B' else btnB.Caption:='G';
 end;

end;

procedure TfrmPanel.btnCMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 if button=mbRight then begin
  if subbiquads[3].state=bsEQ then subbiquads[3].state:=bsGain else
  subbiquads[3].state:=bsEQ;
  if subbiquads[3].state=bsEQ then btnC.Caption:='C' else btnC.Caption:='G';
 end;

end;

procedure TfrmPanel.btnAClick(Sender: TObject);
var dialog:TfrmFilterSetup;id:integer;
begin
 id:=1;
 if sender=btnB then id:=2;
 if sender=btnC then id:=3;
 dialog:=TfrmFilterSetup.Create(frmPanel);
 if subbiquads[id].state=bsGain then begin
  dialog.rgKind.ItemIndex:=1;
  dialog.edFreq.Enabled:=false;
  dialog.edQ.Enabled:=false;
 end;
 dialog.edFreq.Text:=formatfloat('0.0',subbiquads[id].freq);
 dialog.edQ.Text:=formatfloat('0.000',subbiquads[id].q);
 if dialog.ShowModal=mrOK then begin
  try
   subbiquads[id].freq:=StrToFloat(dialog.edFreq.text);
   subbiquads[id].q:=StrToFloat(dialog.edQ.text);
   if dialog.rgKind.ItemIndex=1 then subbiquads[id].state:=bsGain else subbiquads[id].state:=bsEQ;
  except
   on E:Exception do Showmessage('Chyba: '+E.message);
  end;
 end;
 dialog.Free;
 SetSubBiquad(sender);
end;

procedure TfrmPanel.sbSamplesChange(Sender: TObject);
begin
 AD.Cmd(191,0,sbSamples.Position div $100,sbSamples.Position and $FF);
 lblSamples.caption:=inttostr(sbSamples.Position div 48)+' ms';
end;

procedure TfrmPanel.sbGainChange(Sender: TObject);
begin
 lblGain.caption:='x '+formatfloat('0.00',(200-sbGain.Position)*0.01);
 AD.CmdSafe(144,(200-sbGain.Position)*0.01);
end;

procedure TfrmPanel.btnLSaveClick(Sender: TObject);
var f:file of integer;i:integer;
begin
 if SaveDialog1.Execute then begin
  assignfile(f,savedialog1.FileName);
  rewrite(f);
  for i:=1 to 33 do
     if sender<>btnSubLimSave then write(f,mainlim[i].output) else write(f,sublim[i].output);;

  closefile(f);
 end;
end;

procedure TfrmPanel.btnLOpenClick(Sender: TObject);
var f:file of integer;i,j:integer;
begin
 if OpenDialog1.Execute then begin
  assignfile(f,opendialog1.FileName);
  system.reset(f);
  for i:=1 to 33 do begin
   read(f,j);
   if sender<>btnSLimLoad then mainlim[i].output:=j else sublim[i].output:=j;
  end;
  closefile(f);
 end;
 DrawSLimiter;
 DrawLimiter;
end;

procedure TfrmPanel.sbStereoExpLevelChange(Sender: TObject);
begin
 lblStereoExpLevel.Caption:=formatfloat('0.0',(100-sbStereoExpLevel.Position)/100);
 if AD.GetMute=false then begin
         AD.SetMute(true);
         AD.CmdSafe(185,(100-sbStereoExpLevel.Position)/100);
         AD.SetMute(false);
 end else begin
         AD.CmdSafe(185,(100-sbStereoExpLevel.Position)/100);
 end;


end;

procedure TfrmPanel.sbStereoExpMaxFreqChange(Sender: TObject);
begin
 lblMaxFreq.caption:=inttostr(3000-sbStereoExpMaxFreq.Position)+' Hz';
 AD.CmdSafe(186,1-exp((-2*pi*(3000-sbStereoExpMaxFreq.Position))/48000));
end;

procedure TfrmPanel.imgLimiterMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
 //zpracuje pohyb mysi
 if (x in [3..125]) and (y in [3..125]) then begin
  lblDb.Caption:='IN:'+inttostr(((x-3) div 4)*3-87)+'dB';
  //3+((i+87) div 3)*4
  lblDbOUT.Caption:='OUT:'+inttostr(((125-y) div 4)*3-87)+'dB';
 end;

end;

procedure TfrmPanel.DrawLimiter;
var i,x,y,j,newdb,olddb,olddbi:integer;
begin
 imgLimiter.Canvas.Brush.Style:=bsSolid;
 imgLimiter.Canvas.Brush.Color:=clWhite;
 imgLimiter.Canvas.Pen.Color:=clAqua;
 imgLimiter.Canvas.Rectangle(0,0,129,129);
 for i:=-87 to 3 do begin
  if (i mod 3)<>0 then Continue;
  //kresli vodorovne - zdroj.signal
  imgLimiter.Canvas.MoveTo(3,6-(i div 3)*4);
  imgLimiter.Canvas.LineTo(127,6-(i div 3)*4);
  //kresli svisle - vysl. signal
  imgLimiter.Canvas.MoveTo(3+((i+87) div 3)*4,3);
  imgLimiter.Canvas.LineTo(3+((i+87) div 3)*4,127);
 end;
 //kresli norm. prubeh
 imgLimiter.Canvas.MoveTo(3,6-(-87 div 3)*4);
 imgLimiter.Canvas.LineTo(3+(90 div 3)*4,3);
 //kresli body
 imgLimiter.Canvas.Brush.Color:=clRed;
 imgLimiter.Canvas.Pen.Color:=clBlack;
 for i:=3 to 33 do begin
  if mainlim[i].output>-150 then begin
   x:=(i-3)*3-87;
   x:=3+((x+87) div 3)*4;
   y:=mainlim[i].output;
   y:=125-(3+((y+87) div 3)*4);
//   showmessage(inttostr(x)+' '+inttostr(y));
   imgLimiter.Canvas.Ellipse(x-2,y-2,x+2,y+2);
  end;
 end;
 //vypocitej krivku
 olddb:=1;  olddbi:=1;
 for i:=1 to 33 do begin
  if mainlim[i].output>-150 then begin
   mainlim[i].outputq:=mainlim[i].output;
   olddb:=mainlim[i].output;
   olddbi:=i;
  end else begin
   //najdi nejblizsi zadanou hodnotu
   newdb:=33;
   for j:=i+1 to 33 do if mainlim[j].output>-150 then begin
    newdb:=mainlim[j].output;
    break;
   end;
   mainlim[i].outputq:=round((newdb-olddb)*((i-olddbi)/(j-olddbi))+olddb);
  end;
 end;
 //vypocitej pomery
 ldLimErr.State:=lsOff;
 for i:=1 to 33 do begin
  mainlim[i].gain:=mocnina(10,(mainlim[i].outputq-(i*3-96))/20);
  if mainlim[i].gain>1.999 then ldLimErr.State:=lsOn;
 end;
 //vykresli krivku
 i:=3;
   x:=(i-3)*3-87;
   x:=3+((x+87) div 3)*4;
   y:=mainlim[i].outputq;
   y:=125-(3+((y+87) div 3)*4);
 imgLimiter.canvas.Pen.Color:=clBlack;
   imgLimiter.Canvas.MoveTo(x,y);
 for i:=4 to 33 do begin
   x:=(i-3)*3-87;
   x:=3+((x+87) div 3)*4;
   y:=mainlim[i].outputq;
   y:=125-(3+((y+87) div 3)*4);
   imgLimiter.Canvas.LineTo(x,y);
 end;
 //odesli krivku do limiteru
 //posle data do limiteru
 for i:=1 to 33 do begin
  AD.Cmd(109+i,mainlim[i].gain);
 end;
end;


procedure TfrmPanel.imgLimiterMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if not (x in [3..125]) then exit;
 if button=mbLeft then begin
  //pridej bod do dat limiteru
  try
   mainlim[3+(((x-3) div 4)*3) div 3].output:=strtoint(inputbox('AD1954','Zadejte prosm vslednou velikost signlu pro vstup '+inttostr((((x-3) div 4)*3)-87)+'dB [dB]:',inttostr(((125-y) div 4)*3-87)));
  except
   ShowMessage('Prosm, zadejte cel slo [dB].');
  end;
 end;
 if button=mbRight then begin
  //odeber bod limiteru
  if not ((3+(((x-3) div 4)*3) div 3)=33) then //nepovol smazani nejvyssiho bodu
   mainlim[3+(((x-3) div 4)*3) div 3].output:=-1000;
 end;
 DrawLimiter;
end;

procedure TfrmPanel.sbReinjectLeftChange(Sender: TObject);
var subrel,subrer:real;
begin
 subrel:=(20-sbReinjectLeft.Position)*0.1;
 subrer:=(20-sbReinjectRight.Position)*0.1;
 lblReinject.caption:=formatfloat('0.0',subrel)+' / '+formatfloat('0.0',subrer);
 AD.CmdSafe(187,subrel);
 AD.CmdSafe(188,subrer);

end;

procedure TfrmPanel.imgSLimiterMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 if not (x in [3..125]) then exit;
 if button=mbLeft then begin
  //pridej bod do dat limiteru
  try
   sublim[3+(((x-3) div 4)*3) div 3].output:=strtoint(inputbox('AD1954','Zadejte prosm vslednou velikost signlu pro vstup '+inttostr((((x-3) div 4)*3)-87)+'dB [dB]:',inttostr(((125-y) div 4)*3-87)));
  except
   ShowMessage('Prosm, zadejte cel slo [dB].');
  end;
 end;
 if button=mbRight then begin
  //odeber bod limiteru
  if not ((3+(((x-3) div 4)*3) div 3)=33) then //nepovol smazani nejvyssiho bodu
    sublim[3+(((x-3) div 4)*3) div 3].output:=-1000;
 end;
 DrawSLimiter;
end;

procedure TfrmPanel.imgSLimiterMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
 //zpracuje pohyb mysi
 if (x in [3..125]) and (y in [3..125]) then begin
  lblSDb.Caption:='IN:'+inttostr(((x-3) div 4)*3-87)+'dB';
  //3+((i+87) div 3)*4
  lblSDbOUT.Caption:='OUT:'+inttostr(((125-y) div 4)*3-87)+'dB';
 end;
end;

procedure TfrmPanel.DrawSLimiter;
var i,x,y,j,newdb,olddb,olddbi:integer;
begin
 imgSLimiter.Canvas.Brush.Style:=bsSolid;
 imgSLimiter.Canvas.Brush.Color:=clWhite;
 imgSLimiter.Canvas.Pen.Color:=clAqua;
 imgSLimiter.Canvas.Rectangle(0,0,129,129);
 for i:=-87 to 3 do begin
  if (i mod 3)<>0 then Continue;
  //kresli vodorovne - zdroj.signal
  imgSLimiter.Canvas.MoveTo(3,6-(i div 3)*4);
  imgSLimiter.Canvas.LineTo(127,6-(i div 3)*4);
  //kresli svisle - vysl. signal
  imgSLimiter.Canvas.MoveTo(3+((i+87) div 3)*4,3);
  imgSLimiter.Canvas.LineTo(3+((i+87) div 3)*4,127);
 end;
 //kresli norm. prubeh
 imgSLimiter.Canvas.MoveTo(3,6-(-87 div 3)*4);
 imgSLimiter.Canvas.LineTo(3+(90 div 3)*4,3);
 //kresli body
 imgSLimiter.Canvas.Brush.Color:=clRed;
 imgSLimiter.Canvas.Pen.Color:=clBlack;
 for i:=3 to 33 do begin
  if  sublim[i].output>-150 then begin
   x:=(i-3)*3-87;
   x:=3+((x+87) div 3)*4;
   y:= sublim[i].output;
   y:=125-(3+((y+87) div 3)*4);
//   showmessage(inttostr(x)+' '+inttostr(y));
   imgSLimiter.Canvas.Ellipse(x-2,y-2,x+2,y+2);
  end;
 end;
 //vypocitej krivku
 newdb:=33;olddb:=1;olddbi:=1;
 for i:=1 to 33 do begin
  if  sublim[i].output>-150 then begin
    sublim[i].outputq:= sublim[i].output;
   olddb:= sublim[i].output;
   olddbi:=i;
  end else begin
   //najdi nejblizsi zadanou hodnotu
   for j:=i+1 to 33 do if  sublim[j].output>-150 then begin
    newdb:= sublim[j].output;
    break;
   end;
    sublim[i].outputq:=round((newdb-olddb)*((i-olddbi)/(j-olddbi))+olddb);
  end;
 end;
 //vypocitej pomery
 ldSLimErr.State:=lsOff;
 for i:=1 to 33 do begin
   sublim[i].gain:=mocnina(10,( sublim[i].outputq-(i*3-96))/20);
  if sublim[i].gain>1.999 then ldSLimErr.State:=lsOn;
 end;
 //vykresli krivku
 i:=3;
   x:=(i-3)*3-87;
   x:=3+((x+87) div 3)*4;
   y:=sublim[i].outputq;
   y:=125-(3+((y+87) div 3)*4);
 imgSLimiter.canvas.Pen.Color:=clBlack;
   imgSLimiter.Canvas.MoveTo(x,y);
 for i:=4 to 33 do begin
   x:=(i-3)*3-87;
   x:=3+((x+87) div 3)*4;
   y:=sublim[i].outputq;
   y:=125-(3+((y+87) div 3)*4);
   imgSLimiter.Canvas.LineTo(x,y);
 end;
 //odesli krivku do limiteru
 //posle data do limiteru
 for i:=1 to 33 do begin
  AD.Cmd(144+i,sublim[i].gain);
 end;
end;



procedure TfrmPanel.sbSSamplesChange(Sender: TObject);
begin
 AD.Cmd(192,0,sbSSamples.Position div $100,sbSSamples.Position and $FF);
 lblSSamples.caption:=inttostr(sbSSamples.Position div 48)+' ms';
end;

procedure TfrmPanel.sbSGainChange(Sender: TObject);
begin
 lblSGain.caption:='x '+formatfloat('0.00',(200-sbSGain.Position)*0.01);
 AD.CmdSafe(179,(200-sbSGain.Position)*0.01);
end;

procedure TfrmPanel.btnMainToSubClick(Sender: TObject);
var i:integer;
begin
 for i:=1 to 33 do sublim[i].output:=mainlim[i].output;
 DrawSLimiter;
end;

procedure TfrmPanel.btnSubToMainClick(Sender: TObject);
var i:integer;
begin
 for i:=1 to 33 do mainlim[i].output:=sublim[i].output;
 DrawLimiter;
end;

procedure TfrmPanel.btnVUClick(Sender: TObject);
begin
 if not tVUMetr.Enabled then begin
  //bude se zapinat - natahni registry
  ldVUMetr.State:=lsOn;
  AD.Cmd(262,(154*4) div $100,((154*4) and $FF)+1); //main
  AD.Cmd(261,(489*4) div $100,((489*4) and $FF)+1); //sub
 end else begin
  ldVUMetr.State:=lsOff;
  if vulimiter then btnVULimiterClick(sender);
 end;
 tVUMetr.Enabled:=not tVUMetr.Enabled;
 pbMain.Visible:=tVUMetr.Enabled;
 pbSub.Visible:=tVUMetr.Enabled;
 if tVUMetr.Enabled then (backlink as TADHandler).pbMix.Height:=97 else (backlink as TADHandler).pbMix.Height:=5; 
end;

procedure TfrmPanel.tVUMetrTimer(Sender: TObject);
var y:integer;
begin
 //hlavni limiter
  y:=AD.GetCapture(262);
  y:=round(-87+3*(y/524288));
  label1.caption:=inttostr(y)+' dB';
  //progressbar
  if y<-35 then pbMain.Position:=-35 else pbMain.Position:=y;
  if y<-35 then (backlink as TADHandler).pbMix.Position:=-35 else (backlink as TADHandler).pbMix.Position:=y;
  //ukazatel vstupu limiteru
  if (y>-70) and vulimiter then begin
   shMLIn.Visible:=true;
   shMLOut.Visible:=true;
   shMLIn.Left:=imgLimiter.Left+3+round(((y+87)/3))*4;
   //ukazatel vystupu limiteru - napred zjisti zesileni
   if y>3 then y:=3;
   y:=mainlim[(y+87) div 3+3].outputq; //vyst.signal pro dany vstup.signal
   shMLOut.Top:=imgLimiter.Top+125-(3+((y+87) div 3)*4);
  end else begin
   shMLIn.Visible:=false;
   shMLOut.Visible:=false;
  end;

 //sub limiter
  y:=AD.GetCapture(261);
  y:=round(-87+3*(y/524288));
  label2.caption:=inttostr(y)+' dB';
  //progressbar
  if y<-35 then pbSub.Position:=-35 else pbSub.Position:=y;
  //ukazatel vstupu limiteru
  if (y>-70) and vulimiter then begin
   shSLIn.Visible:=true;
   shSLOut.Visible:=true;
   shSLIn.Left:=imgSLimiter.Left+3+round(((y+87)/3))*4;
   //ukazatel vystupu limiteru - napred zjisti zesileni
   if y>3 then y:=3;
   y:=sublim[(y+87) div 3+3].outputq; //vyst.signal pro dany vstup.signal
   shSLOut.Top:=imgSLimiter.Top+125-(3+((y+87) div 3)*4);
  end else begin
   shSLIn.Visible:=false;
   shSLOut.Visible:=false;
  end;
end;

procedure TfrmPanel.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 if tVUMetr.Enabled then btnVUClick(sender); 
end;

procedure TfrmPanel.btnVULimiterClick(Sender: TObject);
begin
 if VULimiter then begin
  //vypni
  ldVULimiter.State:=lsOff;
 end else begin
  //zapni
  ldVULimiter.State:=lsOn;
  if not tVUMetr.Enabled then btnVUClick(sender);
 end;
 VULimiter:=not VULimiter;
 shMLIn.Visible:=VULimiter;
 shSLIn.Visible:=VULimiter;
 shMLOut.Visible:=VULimiter;
 shSLOut.Visible:=VULimiter;

end;

procedure TfrmPanel.btnEQSaveClick(Sender: TObject);
var f:file of TEqBand;band:TEQBand;
    i:integer;
begin
 if SaveDialog2.Execute then begin
  try
  assignfile(f,savedialog2.filename);
  rewrite(f);
  for i:=1 to 9 do begin
   band.freq:=biquads[i].freq;
   band.q:=biquads[i].q;
   band.state:=biquads[i].state;
   band.connect:=biquads[i].connect;
   band.posleft:=biquads[i].sbLeft.Position;
   band.posright:=biquads[i].sbRight.Position;
   write(f,band);
  end;
  closefile(f);
  except
   on E:Exception do showmessage('Chyba: '+E.Message);
  end;
 end;
end;

procedure TfrmPanel.btnEQLoadClick(Sender: TObject);
var f:file of TEqBand;band:TEQBand;
    i:integer;
begin
 if OpenDialog2.Execute then begin
  try
  assignfile(f,opendialog2.filename);
  reset(f);
  for i:=1 to 9 do begin
   read(f,band);
   biquads[i].freq:=band.freq;
   biquads[i].q:=band.q;
   biquads[i].state:=band.state;
   biquads[i].connect:=band.connect;
   biquads[i].sbLeft.Position:=band.posleft;
   biquads[i].sbRight.Position:=band.posright;
   biquads[i].RedrawUI;
  end;
  closefile(f);
  except
   on E:Exception do showmessage('Chyba: '+E.Message);
  end;
 end;

end;

procedure TfrmPanel.FormShow(Sender: TObject);
begin
 visibleLed.state:=lsOn;
end;

procedure TfrmPanel.FormHide(Sender: TObject);
begin
 visibleLed.state:=lsOff;
end;

procedure TfrmPanel.btnVUMetrMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
 btnVUClick(sender); //aby to mohl volat i click na progressbar, nemuzu pouzit OnClick
end;

end.
