unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, dkTranslator, ExtCtrls, ComCtrls, mLED, dkPanel;

type
  TfrmMain = class(TForm)
    Button2: TButton;
    Bevel1: TBevel;
    Label1: TLabel;
    lblStav: TLabel;
    lbDevices: TListBox;
    btnOdeber: TButton;
    btnPridej: TButton;
    lblName: TLabel;
    cbAddr: TComboBox;
    lblAddr: TLabel;
    edJmeno: TEdit;
    Label2: TLabel;
    cbSvazPanely: TCheckBox;
    btnZobraz: TButton;
    btnStop: TButton;
    cbComm: TComboBox;
    Label3: TLabel;
    procedure AlignPanel;
    procedure Button2Click(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure lbDevicesDblClick(Sender: TObject);
    procedure btnPridejClick(Sender: TObject);
    procedure btnOdeberClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbCommChange(Sender: TObject);
    procedure btnZobrazClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

type TDevInfo=record
                clport,clval:integer;
                neguje:boolean;
                jmeno:shortstring;
              end;
type TADHandler=class
                        frmPanel:TfrmPanel;
                        devinfo:TDevInfo;
                        index:integer;
                        sbMix:TScrollBar;
                        pbMix:TProgressBar;
                        lblMix:TLabel;
                        ldMute:TMLed;
                        ldShow:TMLed;
                        constructor Create(port,cport,cval:integer;neg:boolean);
                        procedure ShowWindow;
                        procedure HideWindow;
                        procedure ShowThis(sender:TObject);
                end;


var
  frmMain: TfrmMain;
  GlobalLPT:integer;

var GloAD:TAD1954;

implementation
uses LPTComm;
{$R *.dfm}

procedure TADHandler.ShowThis(sender:Tobject);
begin
 //simuluje dvojkik na seznamu
 frmMain.lbDevices.itemIndex:=index;
 frmMain.lbDevicesDblClick(sender);
end;


constructor TADHandler.Create(port,cport,cval:integer;neg:boolean);
begin
 devinfo.clport:=cport;
 devinfo.clval:=cval;
 devinfo.neguje:=neg;
 frmPanel:=TfrmPanel.Create(frmPanel);
 frmPanel.backlink:=self;
 frmPanel.FormCreateEx(frmPanel);
 CreateFilters(frmPanel);
 sbMix:=TScrollBar.Create(frmMain);
 sbMix.Parent:=frmMain;
 sbMix.Top:=50;
 sbMix.Max:=460;
 sbMix.Position:=60;
 sbMix.Kind:=sbVertical;
 sbMix.Width:=16;
 sbMix.Height:=95;
 sbMix.Left:=293;
 sbMix.OnChange:=frmPanel.sbVolLeftChange;
 lblMix:=TLabel.Create(frmMain);
 lblMix.Parent:=frmMain;
 lblMix.Top:=147;
 lblMix.Width:=22;
 lblMix.Caption:='---';
 lblMix.Left:=290;
 pbMix:=TProgressBar.Create(frmMain);
 pbMix.Parent:=frmMain;
 pbMix.Smooth:=true;
 pbMix.Orientation:=pbVertical;
 pbMix.Min:=-35;
 pbMix.Max:=9;
 pbMix.Left:=310;
 pbMix.Top:=48;
 pbMix.Width:=9;
 pbMix.Height:=5;
 pbMix.Position:=-35;
 pbMix.OnMouseDown:=frmPanel.btnVUMetr.OnMouseDown;
 ldMute:=TMLed.Create(frmMain);
 ldShow:=TMLed.Create(frmMain);
 ldMute.Parent:=frmMain;
 ldMute.Color:=lcRed;
 ldMute.State:=lsOff;
 ldShow.Parent:=frmMain;
 ldShow.Color:=lcBlue;
 ldShow.State:=lsOff;
 ldMute.Top:=3;
 ldMute.OnClick:=frmPanel.btnMute.OnClick;
 ldShow.Top:=24;
// zobrazi, ale NENASTAVUJE VLASTNOST LEFT - to udela jina procedura (alignpanel)
// pro vstupy vsechny zaroven!
 sbMix.Visible:=true;
 lblMix.Visible:=true;
 pbMix.Visible:=true;
 ldShow.OnClick:=ShowThis;
 frmPanel.visibleLed:=ldShow;
end;

procedure TADHandler.ShowWindow;
begin
 frmPanel.Caption:=devinfo.jmeno+': port '+inttostr(devinfo.clport)+'/'+inttostr(devinfo.clval);
 frmPanel.Show;
end;

procedure TADHandler.HideWindow;
begin
 frmPanel.Hide;
end;

procedure TfrmMain.AlignPanel;
var i:integer;
begin
 for i:=0 to lbDevices.items.Count-1 do begin
  with (lbDevices.Items.Objects[i] as TADHandler) do begin
   lblMix.Left:=291+32*i;
   pbMix.Left:=310+32*i;
   sbMix.Left:=293+32*i;
   ldMute.Left:=292+32*i;
   ldShow.Left:=292+32*i;
   index:=i;
   lblMix.Caption:=copy(devinfo.jmeno,0,5);
  end;
 end;
 width:=496-(6-lbDevices.items.Count)*32;
end;


procedure TfrmMain.Button2Click(Sender: TObject);
var i:integer;
begin
 lblStav.Caption:='Resetuji...';
 Application.ProcessMessages;
 GloAD.Reset;
 lblStav.Caption:='ekm na AD...';
 sleep(800);
 for i:=0 to lbDevices.Items.count-1 do begin
  lblStav.Caption:='Inicializace... ('+(lbDevices.Items.Objects[i] as TADHandler).devinfo.jmeno+')';
  Application.ProcessMessages;
  (lbDevices.Items.Objects[i] as TADHandler).frmPanel.AD.Init;
  showmessage(inttostr((lbDevices.Items.Objects[i] as TADHandler).frmPanel.AD.adlatchport));
  sleep(100);
 end;
 lblStav.Caption:='Pipraven';
end;

procedure TfrmMain.btnStopClick(Sender: TObject);
begin
 Application.terminate;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var f:file of TDevInfo;di:TDevInfo;ind:integer;
begin
 //nacti data o pripojenych zarizenich
 GloAD:=TAD1954.CreateLPT($378,$378,2,false);
 GlobalLPT:=$378;
 lbDevices.Items.Clear;
 try
  assignfile(f,'devices.ini');
  reset(f);
  while not eof(f) do begin
   read(f,di);
   ind:=lbDevices.Items.Add(di.jmeno);
   lbDevices.Items.Objects[ind]:=TADHandler.Create(GlobalLPT,di.clport,di.clval,di.neguje);
   (lbDevices.Items.Objects[ind] as TADHandler).index:=ind;
   (lbDevices.Items.Objects[ind] as TADHandler).devinfo:=di;
  end;
  closefile(f);
 except
  on E:Exception do Showmessage('Nelze nacist nastaveni zarizeni: '+E.Message);
 end;
 alignpanel;
end;

procedure TfrmMain.lbDevicesDblClick(Sender: TObject);
var i:integer;
begin
 for i:=0 to lbDevices.Items.Count-1 do
  (lbDevices.Items.Objects[i] As TADHandler).HideWindow;
  (lbDevices.Items.Objects[lbDevices.ItemIndex] As TADHandler).ShowWindow;
 if cbSvazPanely.Checked then begin
  (lbDevices.Items.Objects[lbDevices.ItemIndex] As TADHandler).frmPanel.top:=frmMain.Top+frmMain.Height;
  (lbDevices.Items.Objects[lbDevices.ItemIndex] As TADHandler).frmPanel.left:=frmMain.left;
 end;
end;

procedure TfrmMain.btnPridejClick(Sender: TObject);
var di:TDevInfo;  ind:integer;
begin
   if edJmeno.text='' then exit;
   if lbDevices.items.count=6 then begin
    showmessage('Maximalni pocet ovladanych AD1954 je 6.');
   end;
   di.jmeno:=edJmeno.Text;
   if (cbaddr.Text='SJ5') or (cbaddr.Text='SJ6') then
    di.clport:=$37A else di.clport:=$378;
   case cbaddr.Text[3] of
    '1':di.clval:=64;
    '2':di.clval:=32;
    '3':di.clval:=16;
    '4':di.clval:=2;
    '5':di.clval:=8;
    '6':di.clval:=4;
   end;
   di.neguje:=(cbAddr.text='SJ5');
   ind:=lbDevices.Items.Add(di.jmeno);
   lbDevices.Items.Objects[ind]:=TADHandler.Create(GlobalLPT,di.clport,di.clval,di.neguje);
   (lbDevices.Items.Objects[ind] as TADHandler).devinfo:=di;
   showmessage('Pridano - port '+inttostr((lbDevices.Items.Objects[ind] as TADHandler).devinfo.clport)+'/ hodnota'+inttostr((lbDevices.Items.Objects[ind] as TADHandler).devinfo.clval));
   alignpanel;
end;

procedure TfrmMain.btnOdeberClick(Sender: TObject);
begin
 if lbDevices.ItemIndex>=0 then begin
  (lbDevices.Items.Objects[lbDevices.ItemIndex] as TADHandler).frmPanel.Hide;
  (lbDevices.Items.Objects[lbDevices.ItemIndex] as TADHandler).frmPanel.Release;
  (lbDevices.Items.Objects[lbDevices.ItemIndex] as TADHandler).sbMix.Free;
  (lbDevices.Items.Objects[lbDevices.ItemIndex] as TADHandler).pbMix.Free;
  (lbDevices.Items.Objects[lbDevices.ItemIndex] as TADHandler).lblMix.Free;
  (lbDevices.Items.Objects[lbDevices.ItemIndex] as TADHandler).ldMute.Free;
  (lbDevices.Items.Objects[lbDevices.ItemIndex] as TADHandler).ldShow.Free;
  (lbDevices.Items.Objects[lbDevices.ItemIndex] as TADHandler).Free;
  lbDevices.Items.Delete(lbDevices.ItemIndex);
 end;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
var i:integer;f:file of TDevInfo;di:TDevInfo;
begin
 //uloz data
 try
  assignfile(f,'devices.ini');
  rewrite(f);
  for i:=0 to lbDevices.items.count-1 do begin
   write(f,(lbDevices.items.objects[i] as TADHandler).DevInfo);
  end;
  closefile(f);
 except
  on E:Exception do Showmessage('Nelze nacist nastaveni zarizeni: '+E.Message);
 end;
 alignpanel;


 //znic ADHandlery
 for i:=0 to lbDevices.items.count-1 do begin
  (lbDevices.Items.Objects[i] as TADHandler).frmPanel.Hide;
  (lbDevices.Items.Objects[i] as TADHandler).frmPanel.Release;
  (lbDevices.Items.Objects[i] as TADHandler).Free;
 end;
end;

procedure TfrmMain.cbCommChange(Sender: TObject);
begin
 LPTCOmm.waitnum:=strtoint(trim(copy(cbComm.text,0,7)));
end;

procedure TfrmMain.btnZobrazClick(Sender: TObject);
begin
 if lbDevices.ItemIndex>=0 then lbDevicesDblClick(sender);
end;

end.
